"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const cachedScripts = [];

const getDisplayName = name => `withScriptLoader(${name})`;

const withScriptLoader = (...scripts) => WrappedComponent => {
  class ScriptLoader extends _react.Component {
    constructor(props) {
      super(props);

      _defineProperty(this, "loadScripts", scripts => {
        const promises = scripts.map(script => typeof script === 'object' ? script : {
          src: script
        }).filter(script => !cachedScripts.includes(script.src)).map(script => this.loadScript(script));
        Promise.all(promises).then(() => {
          this._isMounted && this.setState({
            hasScriptsLoaded: true,
            hasScriptsLoadedSuccessfully: true
          });
        }).catch(() => {
          this._isMounted && this.setState({
            hasScriptsLoaded: true,
            hasScriptsLoadedSuccessfully: false
          });
        });
      });

      _defineProperty(this, "loadScript", (_ref) => {
        let {
          src
        } = _ref,
            attributes = _objectWithoutProperties(_ref, ["src"]);

        cachedScripts.push(src);
        const script = document.createElement('script');
        script.src = src;
        Object.keys(attributes).forEach(key => script[key] = attributes[key]);
        const promise = new Promise((resolve, reject) => {
          script.addEventListener('load', () => resolve(src));
          script.addEventListener('error', error => reject(error));
        }).catch(error => {
          const index = cachedScripts.indexOf(src);
          if (index >= 0) cachedScripts.splice(index, 1);
          script.remove();
          throw error;
        });
        document.body.appendChild(script);
        return promise;
      });

      this._isMounted = false;
      this.state = {
        hasScriptsLoaded: false,
        hasScriptsLoadedSuccessfully: false
      };
    }

    componentDidMount() {
      this._isMounted = true;
      this.loadScripts(scripts);
    }

    componentWillUnmount() {
      this._isMounted = false;
    }

    render() {
      return _react.default.createElement(WrappedComponent, _extends({}, this.props, this.state));
    }

  }

  const name = WrappedComponent.displayName || WrappedComponent.name || 'Component';
  ScriptLoader.displayName = getDisplayName(name);
  ScriptLoader.WrappedComponent = WrappedComponent;
  return (0, _hoistNonReactStatics.default)(ScriptLoader, WrappedComponent);
};

var _default = withScriptLoader;
exports.default = _default;